API specs
Managing and interacting with Azure OpenAI models and resources is divided across three primary API surfaces:- Control plane
- Data plane - authoring
- Data plane - inference
There is now a new preview inference API. Learn more in our API lifecycle guide.
| API | Latest preview release | Latest GA release | Specifications | Description |
|---|---|---|---|---|
| Control plane | 2025-07-01-preview | 2025-06-01 | Spec files | The control plane API is used for operations like creating resources, model deployment, and other higher level resource management tasks. The control plane also governs what is possible to do with capabilities like Azure Resource Manager, Bicep, Terraform, and Azure CLI. |
| Data plane | v1 preview | v1 | Spec files | The data plane API controls inference and authoring operations. |
Authentication
Azure OpenAI provides two methods for authentication. You can use either API Keys or Microsoft Entra ID.-
API Key authentication: For this type of authentication, all API requests must include the API Key in the
api-keyHTTP header. The Quickstart provides guidance for how to make calls with this type of authentication. -
Microsoft Entra ID authentication: You can authenticate an API call using a Microsoft Entra token. Authentication tokens are included in a request as the
Authorizationheader. The token provided must be preceded byBearer, for exampleBearer YOUR_AUTH_TOKEN. You can read our how-to guide on authenticating with Microsoft Entra ID.
REST API versioning
The service APIs are versioned using theapi-version query parameter. All versions follow the YYYY-MM-DD date structure. For example:
Data plane inference
The rest of the article covers the GA release of the Azure OpenAI data plane inference specification,2024-10-21.
If you’re looking for documentation on the latest preview API release, refer to the latest preview data plane inference API.
Completions
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | path | Yes | string url | Supported Azure OpenAI endpoints (protocol and hostname, for example: https://aoairesource.openai.azure.com. Replace “aoairesource” with your Azure OpenAI resource name). https://{your-resource-name}.openai.azure.com |
| deployment-id | path | Yes | string | Deployment ID of the model which was deployed. |
| api-version | query | Yes | string | API version |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| api-key | True | string | Provide Azure OpenAI API key here |
Request Body
Content-Type: application/json| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| prompt | string or array | The prompt(s) to generate completions for, encoded as a string, array of strings, array of tokens, or array of token arrays. Note that <|endoftext|> is the document separator that the model sees during training, so if a prompt isn’t specified the model will generate as if from the beginning of a new document. | Yes | |
| best_of | integer | Generates best_of completions server-side and returns the “best” (the one with the highest log probability per token). Results can’t be streamed.When used with n, best_of controls the number of candidate completions and n specifies how many to return – best_of must be greater than n.Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for max_tokens and stop. | No | 1 |
| echo | boolean | Echo back the prompt in addition to the completion | No | False |
| frequency_penalty | number | Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model’s likelihood to repeat the same line verbatim. | No | 0 |
| logit_bias | object | Modify the likelihood of specified tokens appearing in the completion. Accepts a JSON object that maps tokens (specified by their token ID in the GPT tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token. As an example, you can pass {"50256": -100} to prevent the <|endoftext|> token from being generated. | No | None |
| logprobs | integer | Include the log probabilities on the logprobs most likely output tokens, as well the chosen tokens. For example, if logprobs is 5, the API will return a list of the five most likely tokens. The API will always return the logprob of the sampled token, so there may be up to logprobs+1 elements in the response.The maximum value for logprobs is 5. | No | None |
| max_tokens | integer | The maximum number of tokens that can be generated in the completion. The token count of your prompt plus max_tokens can’t exceed the model’s context length. | No | 16 |
| n | integer | How many completions to generate for each prompt. Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for max_tokens and stop. | No | 1 |
| presence_penalty | number | Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model’s likelihood to talk about new topics. | No | 0 |
| seed | integer | If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same seed and parameters should return the same result.Determinism isn’t guaranteed, and you should refer to the system_fingerprint response parameter to monitor changes in the backend. | No | |
| stop | string or array | Up to four sequences where the API will stop generating further tokens. The returned text won’t contain the stop sequence. | No | |
| stream | boolean | Whether to stream back partial progress. If set, tokens will be sent as data-only server-sent events as they become available, with the stream terminated by a data: [DONE] message. | No | False |
| suffix | string | The suffix that comes after a completion of inserted text. This parameter is only supported for gpt-3.5-turbo-instruct. | No | None |
| temperature | number | What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or top_p but not both. | No | 1 |
| top_p | number | An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered. We generally recommend altering this or temperature but not both. | No | 1 |
| user | string | A unique identifier representing your end-user, which can help to monitor and detect abuse. | No |
Responses
Status Code: 200 Description: OK| Content-Type | Type | Description |
|---|---|---|
| application/json | createCompletionResponse | Represents a completion response from the API. Note: both the streamed and nonstreamed response objects share the same shape (unlike the chat endpoint). |
| Content-Type | Type | Description |
|---|---|---|
| application/json | errorResponse |
Examples
Example
Creates a completion for the provided prompt, parameters, and chosen model.Embeddings
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | path | Yes | string url | Supported Azure OpenAI endpoints (protocol and hostname, for example: https://aoairesource.openai.azure.com. Replace “aoairesource” with your Azure OpenAI resource name). https://{your-resource-name}.openai.azure.com |
| deployment-id | path | Yes | string | |
| api-version | query | Yes | string | API version |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| api-key | True | string | Provide Azure OpenAI API key here |
Request Body
Content-Type: application/json| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| input | string or array | Input text to embed, encoded as a string or array of tokens. To embed multiple inputs in a single request, pass an array of strings or array of token arrays. The input must not exceed the max input tokens for the model (8,192 tokens for text-embedding-ada-002), can’t be an empty string, and any array must be 2,048 dimensions or less. In addition to the per-input token limit, all embedding models enforce a maximum of 300,000 tokens summed across all inputs in a single request. | Yes | |
| user | string | A unique identifier representing your end-user, which can help monitoring and detecting abuse. | No | |
| input_type | string | input type of embedding search to use | No | |
| encoding_format | string | The format to return the embeddings in. Can be either float or base64. Defaults to float. | No | |
| dimensions | integer | The number of dimensions the resulting output embeddings should have. Only supported in text-embedding-3 and later models. | No |
Responses
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| object | string | Yes | ||
| model | string | Yes | ||
| data | array | Yes | ||
| usage | object | Yes |
Properties for usage
prompt_tokens
| Name | Type | Description | Default |
|---|---|---|---|
| prompt_tokens | integer |
total_tokens
| Name | Type | Description | Default |
|---|---|---|---|
| total_tokens | integer |
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
Examples
Example
Return the embeddings for a given prompt.Chat completions
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | path | Yes | string url | Supported Azure OpenAI endpoints (protocol and hostname, for example: https://aoairesource.openai.azure.com. Replace “aoairesource” with your Azure OpenAI resource name). https://{your-resource-name}.openai.azure.com |
| deployment-id | path | Yes | string | Deployment ID of the model which was deployed. |
| api-version | query | Yes | string | API version |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| api-key | True | string | Provide Azure OpenAI API key here |
Request Body
Content-Type: application/json| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| temperature | number | What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or top_p but not both. | No | 1 |
| top_p | number | An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered. We generally recommend altering this or temperature but not both. | No | 1 |
| stream | boolean | If set, partial message deltas will be sent, like in ChatGPT. Tokens will be sent as data-only server-sent events as they become available, with the stream terminated by a data: [DONE] message. | No | False |
| stop | string or array | Up to four sequences where the API will stop generating further tokens. | No | |
| max_tokens | integer | The maximum number of tokens that can be generated in the chat completion. The total length of input tokens and generated tokens is limited by the model’s context length. | No | |
| max_completion_tokens | integer | An upper bound for the number of tokens that can be generated for a completion, including visible output tokens and reasoning tokens. | No | |
| presence_penalty | number | Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model’s likelihood to talk about new topics. | No | 0 |
| frequency_penalty | number | Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model’s likelihood to repeat the same line verbatim. | No | 0 |
| logit_bias | object | Modify the likelihood of specified tokens appearing in the completion. Accepts a JSON object that maps tokens (specified by their token ID in the tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token. | No | None |
| user | string | A unique identifier representing your end-user, which can help to monitor and detect abuse. | No | |
| messages | array | A list of messages comprising the conversation so far. | Yes | |
| data_sources | array | The configuration entries for Azure OpenAI chat extensions that use them. This additional specification is only compatible with Azure OpenAI. | No | |
| logprobs | boolean | Whether to return log probabilities of the output tokens or not. If true, returns the log probabilities of each output token returned in the content of message. | No | False |
| top_logprobs | integer | An integer between 0 and 20 specifying the number of most likely tokens to return at each token position, each with an associated log probability. logprobs must be set to true if this parameter is used. | No | |
| n | integer | How many chat completion choices to generate for each input message. Note that you’ll be charged based on the number of generated tokens across all of the choices. Keep n as 1 to minimize costs. | No | 1 |
| parallel_tool_calls | ParallelToolCalls | Whether to enable parallel function calling during tool use. | No | True |
| response_format | ResponseFormatText or ResponseFormatJsonObject or ResponseFormatJsonSchema | An object specifying the format that the model must output. Compatible with GPT-4o, GPT-4o mini, GPT-4 Turbo and all GPT-3.5 Turbo models newer than gpt-3.5-turbo-1106.Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which guarantees the model will match your supplied JSON schema.Setting to { "type": "json_object" } enables JSON mode, which guarantees the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly “stuck” request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length. | No | |
| seed | integer | This feature is in Beta. If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same seed and parameters should return the same result.Determinism isn’t guaranteed, and you should refer to the system_fingerprint response parameter to monitor changes in the backend. | No | |
| tools | array | A list of tools the model may call. Currently, only functions are supported as a tool. Use this to provide a list of functions the model may generate JSON inputs for. A max of 128 functions are supported. | No | |
| tool_choice | chatCompletionToolChoiceOption | Controls which (if any) tool is called by the model. none means the model won’t call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools. Specifying a particular tool via {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool. none is the default when no tools are present. auto is the default if tools are present. | No | |
| function_call | string or chatCompletionFunctionCallOption | Deprecated in favor of tool_choice.Controls which (if any) function is called by the model. none means the model won’t call a function and instead generates a message.auto means the model can pick between generating a message or calling a function.Specifying a particular function via {"name": "my_function"} forces the model to call that function.none is the default when no functions are present. auto is the default if functions are present. | No | |
| functions | array | Deprecated in favor of tools.A list of functions the model may generate JSON inputs for. | No |
Responses
Status Code: 200 Description: OK| Content-Type | Type | Description |
|---|---|---|
| application/json | createChatCompletionResponse or createChatCompletionStreamResponse |
| Content-Type | Type | Description |
|---|---|---|
| application/json | errorResponse |
Examples
Example
Creates a completion for the provided prompt, parameters, and chosen model.Example
Creates a completion based on Azure Search data and system-assigned managed identity.Example
Creates a completion based on Azure Search vector data, previous assistant message and user-assigned managed identity.Example
Creates a completion for the provided Azure Cosmos DB.Transcriptions - Create
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | path | Yes | string url | Supported Azure OpenAI endpoints (protocol and hostname, for example: https://aoairesource.openai.azure.com. Replace “aoairesource” with your Azure OpenAI resource name). https://{your-resource-name}.openai.azure.com |
| deployment-id | path | Yes | string | Deployment ID of the speech to text model. For information about supported models, see [/azure/ai-foundry/openai/concepts/models#audio-models]. |
| api-version | query | Yes | string | API version |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| api-key | True | string | Provide Azure OpenAI API key here |
Request Body
Content-Type: multipart/form-data| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file | string | The audio file object to transcribe. | Yes | |
| prompt | string | An optional text to guide the model’s style or continue a previous audio segment. The prompt should match the audio language. | No | |
| response_format | audioResponseFormat | Defines the format of the output. | No | |
| temperature | number | The sampling temperature, between 0 and 1. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. If set to 0, the model will use log probability to automatically increase the temperature until certain thresholds are hit. | No | 0 |
| language | string | The language of the input audio. Supplying the input language in ISO-639-1 format will improve accuracy and latency. | No |
Responses
Status Code: 200 Description: OK| Content-Type | Type | Description |
|---|---|---|
| application/json | audioResponse or audioVerboseResponse | |
| text/plain | string | Transcribed text in the output format (when response_format was one of text, vtt or srt). |
Examples
Example
Gets transcribed text and associated metadata from provided spoken audio data.Example
Gets transcribed text and associated metadata from provided spoken audio data.Translations - Create
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | path | Yes | string url | Supported Azure OpenAI endpoints (protocol and hostname, for example: https://aoairesource.openai.azure.com. Replace “aoairesource” with your Azure OpenAI resource name). https://{your-resource-name}.openai.azure.com |
| deployment-id | path | Yes | string | Deployment ID of the whisper model which was deployed. For information about supported models, see [/azure/ai-foundry/openai/concepts/models#audio-models]. |
| api-version | query | Yes | string | API version |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| api-key | True | string | Provide Azure OpenAI API key here |
Request Body
Content-Type: multipart/form-data| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file | string | The audio file to translate. | Yes | |
| prompt | string | An optional text to guide the model’s style or continue a previous audio segment. The prompt should be in English. | No | |
| response_format | audioResponseFormat | Defines the format of the output. | No | |
| temperature | number | The sampling temperature, between 0 and 1. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. If set to 0, the model will use log probability to automatically increase the temperature until certain thresholds are hit. | No | 0 |
Responses
Status Code: 200 Description: OK| Content-Type | Type | Description |
|---|---|---|
| application/json | audioResponse or audioVerboseResponse | |
| text/plain | string | Transcribed text in the output format (when response_format was one of text, vtt or srt). |
Examples
Example
Gets English language transcribed text and associated metadata from provided spoken audio data.Example
Gets English language transcribed text and associated metadata from provided spoken audio data.Image generation
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | path | Yes | string url | Supported Azure OpenAI endpoints (protocol and hostname, for example: https://aoairesource.openai.azure.com. Replace “aoairesource” with your Azure OpenAI resource name). https://{your-resource-name}.openai.azure.com |
| deployment-id | path | Yes | string | Deployment ID of the dall-e model which was deployed. |
| api-version | query | Yes | string | API version |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| api-key | True | string | Provide Azure OpenAI API key here |
Request Body
Content-Type: application/json| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| prompt | string | A text description of the desired image(s). The maximum length is 4,000 characters. | Yes | |
| n | integer | The number of images to generate. | No | 1 |
| size | imageSize | The size of the generated images. | No | 1024x1024 |
| response_format | imagesResponseFormat | The format in which the generated images are returned. | No | url |
| user | string | A unique identifier representing your end-user, which can help to monitor and detect abuse. | No | |
| quality | imageQuality | The quality of the image that will be generated. | No | standard |
| style | imageStyle | The style of the generated images. | No | vivid |
Responses
Status Code: 200 Description: Ok| Content-Type | Type | Description |
|---|---|---|
| application/json | generateImagesResponse |
| Content-Type | Type | Description |
|---|---|---|
| application/json | dalleErrorResponse |
Examples
Example
Creates images given a prompt.Components
errorResponse
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| error | error | No |
errorBase
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string | No | ||
| message | string | No |
error
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| param | string | No | ||
| type | string | No | ||
| inner_error | innerError | Inner error with additional details. | No |
innerError
Inner error with additional details.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | innerErrorCode | Error codes for the inner error object. | No | |
| content_filter_results | contentFilterPromptResults | Information about the content filtering category (hate, sexual, violence, self_harm), if it has been detected, as well as the severity level (very_low, low, medium, high-scale that determines the intensity and risk level of harmful content) and if it has been filtered or not. Information about jailbreak content and profanity, if it has been detected, and if it has been filtered or not. And information about customer blocklist, if it has been filtered and its id. | No |
innerErrorCode
Error codes for the inner error object. Description: Error codes for the inner error object. Type: string Default: Enum Name: InnerErrorCode Enum Values:| Value | Description |
|---|---|
| ResponsibleAIPolicyViolation | The prompt violated one of more content filter rules. |
dalleErrorResponse
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| error | dalleError | No |
dalleError
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| param | string | No | ||
| type | string | No | ||
| inner_error | dalleInnerError | Inner error with additional details. | No |
dalleInnerError
Inner error with additional details.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | innerErrorCode | Error codes for the inner error object. | No | |
| content_filter_results | dalleFilterResults | Information about the content filtering category (hate, sexual, violence, self_harm), if it has been detected, as well as the severity level (very_low, low, medium, high-scale that determines the intensity and risk level of harmful content) and if it has been filtered or not. Information about jailbreak content and profanity, if it has been detected, and if it has been filtered or not. And information about customer blocklist, if it has been filtered and its id. | No | |
| revised_prompt | string | The prompt that was used to generate the image, if there was any revision to the prompt. | No |
contentFilterResultBase
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| filtered | boolean | Yes |
contentFilterSeverityResult
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| filtered | boolean | Yes | ||
| severity | string | No |
contentFilterDetectedResult
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| filtered | boolean | Yes | ||
| detected | boolean | No |
contentFilterDetectedWithCitationResult
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| citation | object | No |
Properties for citation
URL
| Name | Type | Description | Default |
|---|---|---|---|
| URL | string |
license
| Name | Type | Description | Default |
|---|---|---|---|
| license | string |
contentFilterResultsBase
Information about the content filtering results.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| sexual | contentFilterSeverityResult | No | ||
| violence | contentFilterSeverityResult | No | ||
| hate | contentFilterSeverityResult | No | ||
| self_harm | contentFilterSeverityResult | No | ||
| profanity | contentFilterDetectedResult | No | ||
| error | errorBase | No |
contentFilterPromptResults
Information about the content filtering category (hate, sexual, violence, self_harm), if it has been detected, as well as the severity level (very_low, low, medium, high-scale that determines the intensity and risk level of harmful content) and if it has been filtered or not. Information about jailbreak content and profanity, if it has been detected, and if it has been filtered or not. And information about customer blocklist, if it has been filtered and its id.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| sexual | contentFilterSeverityResult | No | ||
| violence | contentFilterSeverityResult | No | ||
| hate | contentFilterSeverityResult | No | ||
| self_harm | contentFilterSeverityResult | No | ||
| profanity | contentFilterDetectedResult | No | ||
| error | errorBase | No | ||
| jailbreak | contentFilterDetectedResult | No |
contentFilterChoiceResults
Information about the content filtering category (hate, sexual, violence, self_harm), if it has been detected, as well as the severity level (very_low, low, medium, high-scale that determines the intensity and risk level of harmful content) and if it has been filtered or not. Information about third party text and profanity, if it has been detected, and if it has been filtered or not. And information about customer blocklist, if it has been filtered and its id.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| sexual | contentFilterSeverityResult | No | ||
| violence | contentFilterSeverityResult | No | ||
| hate | contentFilterSeverityResult | No | ||
| self_harm | contentFilterSeverityResult | No | ||
| profanity | contentFilterDetectedResult | No | ||
| error | errorBase | No | ||
| protected_material_text | contentFilterDetectedResult | No | ||
| protected_material_code | contentFilterDetectedWithCitationResult | No |
promptFilterResult
Content filtering results for a single prompt in the request.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| prompt_index | integer | No | ||
| content_filter_results | contentFilterPromptResults | Information about the content filtering category (hate, sexual, violence, self_harm), if it has been detected, as well as the severity level (very_low, low, medium, high-scale that determines the intensity and risk level of harmful content) and if it has been filtered or not. Information about jailbreak content and profanity, if it has been detected, and if it has been filtered or not. And information about customer blocklist, if it has been filtered and its id. | No |
promptFilterResults
Content filtering results for zero or more prompts in the request. In a streaming request, results for different prompts may arrive at different times or in different orders. No properties defined for this component.dalleContentFilterResults
Information about the content filtering results.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| sexual | contentFilterSeverityResult | No | ||
| violence | contentFilterSeverityResult | No | ||
| hate | contentFilterSeverityResult | No | ||
| self_harm | contentFilterSeverityResult | No |
dalleFilterResults
Information about the content filtering category (hate, sexual, violence, self_harm), if it has been detected, as well as the severity level (very_low, low, medium, high-scale that determines the intensity and risk level of harmful content) and if it has been filtered or not. Information about jailbreak content and profanity, if it has been detected, and if it has been filtered or not. And information about customer blocklist, if it has been filtered and its id.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| sexual | contentFilterSeverityResult | No | ||
| violence | contentFilterSeverityResult | No | ||
| hate | contentFilterSeverityResult | No | ||
| self_harm | contentFilterSeverityResult | No | ||
| profanity | contentFilterDetectedResult | No | ||
| jailbreak | contentFilterDetectedResult | No |
chatCompletionsRequestCommon
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| temperature | number | What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or top_p but not both. | No | 1 |
| top_p | number | An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered. We generally recommend altering this or temperature but not both. | No | 1 |
| stream | boolean | If set, partial message deltas will be sent, like in ChatGPT. Tokens will be sent as data-only server-sent events as they become available, with the stream terminated by a data: [DONE] message. | No | False |
| stop | string or array | Up to four sequences where the API will stop generating further tokens. | No | |
| max_tokens | integer | The maximum number of tokens allowed for the generated answer. By default, the number of tokens the model can return will be (4096 - prompt tokens). This value is now deprecated in favor of max_completion_tokens, and isn’t compatible with o1 series models. | No | 4096 |
| max_completion_tokens | integer | An upper bound for the number of tokens that can be generated for a completion, including visible output tokens and reasoning tokens. | No | |
| presence_penalty | number | Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model’s likelihood to talk about new topics. | No | 0 |
| frequency_penalty | number | Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model’s likelihood to repeat the same line verbatim. | No | 0 |
| logit_bias | object | Modify the likelihood of specified tokens appearing in the completion. Accepts a json object that maps tokens (specified by their token ID in the tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token. | No | |
| user | string | A unique identifier representing your end-user, which can help Azure OpenAI to monitor and detect abuse. | No |
createCompletionRequest
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| prompt | string or array | The prompt(s) to generate completions for, encoded as a string, array of strings, array of tokens, or array of token arrays. Note that <|endoftext|> is the document separator that the model sees during training, so if a prompt isn’t specified the model will generate as if from the beginning of a new document. | Yes | |
| best_of | integer | Generates best_of completions server-side and returns the “best” (the one with the highest log probability per token). Results can’t be streamed.When used with n, best_of controls the number of candidate completions and n specifies how many to return – best_of must be greater than n.Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for max_tokens and stop. | No | 1 |
| echo | boolean | Echo back the prompt in addition to the completion | No | False |
| frequency_penalty | number | Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model’s likelihood to repeat the same line verbatim. | No | 0 |
| logit_bias | object | Modify the likelihood of specified tokens appearing in the completion. Accepts a JSON object that maps tokens (specified by their token ID in the GPT tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token. As an example, you can pass {"50256": -100} to prevent the <|endoftext|> token from being generated. | No | None |
| logprobs | integer | Include the log probabilities on the logprobs most likely output tokens, as well the chosen tokens. For example, if logprobs is 5, the API will return a list of the five most likely tokens. The API will always return the logprob of the sampled token, so there may be up to logprobs+1 elements in the response.The maximum value for logprobs is 5. | No | None |
| max_tokens | integer | The maximum number of tokens that can be generated in the completion. The token count of your prompt plus max_tokens can’t exceed the model’s context length. | No | 16 |
| n | integer | How many completions to generate for each prompt. Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for max_tokens and stop. | No | 1 |
| presence_penalty | number | Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model’s likelihood to talk about new topics. | No | 0 |
| seed | integer | If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same seed and parameters should return the same result.Determinism isn’t guaranteed, and you should refer to the system_fingerprint response parameter to monitor changes in the backend. | No | |
| stop | string or array | Up to four sequences where the API will stop generating further tokens. The returned text won’t contain the stop sequence. | No | |
| stream | boolean | Whether to stream back partial progress. If set, tokens will be sent as data-only server-sent events as they become available, with the stream terminated by a data: [DONE] message. | No | False |
| suffix | string | The suffix that comes after a completion of inserted text. This parameter is only supported for gpt-3.5-turbo-instruct. | No | None |
| temperature | number | What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or top_p but not both. | No | 1 |
| top_p | number | An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered. We generally recommend altering this or temperature but not both. | No | 1 |
| user | string | A unique identifier representing your end-user, which can help to monitor and detect abuse. | No |
createCompletionResponse
Represents a completion response from the API. Note: both the streamed and nonstreamed response objects share the same shape (unlike the chat endpoint).| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| id | string | A unique identifier for the completion. | Yes | |
| choices | array | The list of completion choices the model generated for the input prompt. | Yes | |
| created | integer | The Unix timestamp (in seconds) of when the completion was created. | Yes | |
| model | string | The model used for completion. | Yes | |
| prompt_filter_results | promptFilterResults | Content filtering results for zero or more prompts in the request. In a streaming request, results for different prompts may arrive at different times or in different orders. | No | |
| system_fingerprint | string | This fingerprint represents the backend configuration that the model runs with. Can be used in conjunction with the seed request parameter to understand when backend changes have been made that might impact determinism. | No | |
| object | enum | The object type, which is always “text_completion” Possible values: text_completion | Yes | |
| usage | completionUsage | Usage statistics for the completion request. | No |
createChatCompletionRequest
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| temperature | number | What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or top_p but not both. | No | 1 |
| top_p | number | An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered. We generally recommend altering this or temperature but not both. | No | 1 |
| stream | boolean | If set, partial message deltas will be sent, like in ChatGPT. Tokens will be sent as data-only server-sent events as they become available, with the stream terminated by a data: [DONE] message. | No | False |
| stop | string or array | Up to four sequences where the API will stop generating further tokens. | No | |
| max_tokens | integer | The maximum number of tokens that can be generated in the chat completion. The total length of input tokens and generated tokens is limited by the model’s context length. | No | |
| max_completion_tokens | integer | An upper bound for the number of tokens that can be generated for a completion, including visible output tokens and reasoning tokens. | No | |
| presence_penalty | number | Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model’s likelihood to talk about new topics. | No | 0 |
| frequency_penalty | number | Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model’s likelihood to repeat the same line verbatim. | No | 0 |
| logit_bias | object | Modify the likelihood of specified tokens appearing in the completion. Accepts a JSON object that maps tokens (specified by their token ID in the tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token. | No | None |
| user | string | A unique identifier representing your end-user, which can help to monitor and detect abuse. | No | |
| messages | array | A list of messages comprising the conversation so far. | Yes | |
| data_sources | array | The configuration entries for Azure OpenAI chat extensions that use them. This additional specification is only compatible with Azure OpenAI. | No | |
| logprobs | boolean | Whether to return log probabilities of the output tokens or not. If true, returns the log probabilities of each output token returned in the content of message. | No | False |
| top_logprobs | integer | An integer between 0 and 20 specifying the number of most likely tokens to return at each token position, each with an associated log probability. logprobs must be set to true if this parameter is used. | No | |
| n | integer | How many chat completion choices to generate for each input message. Note that you’ll be charged based on the number of generated tokens across all of the choices. Keep n as 1 to minimize costs. | No | 1 |
| parallel_tool_calls | ParallelToolCalls | Whether to enable parallel function calling during tool use. | No | True |
| response_format | ResponseFormatText or ResponseFormatJsonObject or ResponseFormatJsonSchema | An object specifying the format that the model must output. Compatible with GPT-4o, GPT-4o mini, GPT-4 Turbo and all GPT-3.5 Turbo models newer than gpt-3.5-turbo-1106.Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which guarantees the model will match your supplied JSON schema.Setting to { "type": "json_object" } enables JSON mode, which guarantees the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly “stuck” request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length. | No | |
| seed | integer | This feature is in Beta. If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same seed and parameters should return the same result.Determinism isn’t guaranteed, and you should refer to the system_fingerprint response parameter to monitor changes in the backend. | No | |
| tools | array | A list of tools the model may call. Currently, only functions are supported as a tool. Use this to provide a list of functions the model may generate JSON inputs for. A max of 128 functions are supported. | No | |
| tool_choice | chatCompletionToolChoiceOption | Controls which (if any) tool is called by the model. none means the model won’t call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools. Specifying a particular tool via {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool. none is the default when no tools are present. auto is the default if tools are present. | No | |
| function_call | string or chatCompletionFunctionCallOption | Deprecated in favor of tool_choice.Controls which (if any) function is called by the model. none means the model won’t call a function and instead generates a message.auto means the model can pick between generating a message or calling a function.Specifying a particular function via {"name": "my_function"} forces the model to call that function.none is the default when no functions are present. auto is the default if functions are present. | No | |
| functions | array | Deprecated in favor of tools.A list of functions the model may generate JSON inputs for. | No |
chatCompletionFunctions
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A description of what the function does, used by the model to choose when and how to call the function. | No | |
| name | string | The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64. | Yes | |
| parameters | FunctionParameters | The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format. Omitting parameters defines a function with an empty parameter list. | No |
chatCompletionFunctionCallOption
Specifying a particular function via{"name": "my_function"} forces the model to call that function.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| name | string | The name of the function to call. | Yes |
chatCompletionRequestMessage
This component can be one of the following:chatCompletionRequestSystemMessage
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | string or array | The contents of the system message. | Yes | |
| role | enum | The role of the messages author, in this case system.Possible values: system | Yes | |
| name | string | An optional name for the participant. Provides the model information to differentiate between participants of the same role. | No |
chatCompletionRequestUserMessage
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | string or array | The contents of the user message. | Yes | |
| role | enum | The role of the messages author, in this case user.Possible values: user | Yes | |
| name | string | An optional name for the participant. Provides the model information to differentiate between participants of the same role. | No |
chatCompletionRequestAssistantMessage
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | string or array | The contents of the assistant message. Required unless tool_calls or function_call is specified. | No | |
| refusal | string | The refusal message by the assistant. | No | |
| role | enum | The role of the messages author, in this case assistant.Possible values: assistant | Yes | |
| name | string | An optional name for the participant. Provides the model information to differentiate between participants of the same role. | No | |
| tool_calls | chatCompletionMessageToolCalls | The tool calls generated by the model, such as function calls. | No | |
| function_call | object | Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model. | No |
Properties for function_call
arguments
| Name | Type | Description | Default |
|---|---|---|---|
| arguments | string | The arguments to call the function with, as generated by the model in JSON format. Note that the model doesn’t always generate valid JSON, and may generate parameters not defined by your function schema. Validate the arguments in your code before calling your function. |
name
| Name | Type | Description | Default |
|---|---|---|---|
| name | string | The name of the function to call. |
chatCompletionRequestToolMessage
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| role | enum | The role of the messages author, in this case tool.Possible values: tool | Yes | |
| content | string or array | The contents of the tool message. | Yes | |
| tool_call_id | string | Tool call that this message is responding to. | Yes |
chatCompletionRequestFunctionMessage
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| role | enum | The role of the messages author, in this case function.Possible values: function | Yes | |
| content | string | The contents of the function message. | Yes | |
| name | string | The name of the function to call. | Yes |
chatCompletionRequestSystemMessageContentPart
This component can be one of the following:chatCompletionRequestUserMessageContentPart
This component can be one of the following:chatCompletionRequestAssistantMessageContentPart
This component can be one of the following:chatCompletionRequestToolMessageContentPart
This component can be one of the following:chatCompletionRequestMessageContentPartText
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of the content part. Possible values: text | Yes | |
| text | string | The text content. | Yes |
chatCompletionRequestMessageContentPartImage
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of the content part. Possible values: image_url | Yes | |
| image_url | object | Yes |
Properties for image_url
url
| Name | Type | Description | Default |
|---|---|---|---|
| url | string | Either a URL of the image or the base64 encoded image data. |
detail
| Name | Type | Description | Default |
|---|---|---|---|
| detail | string | Specifies the detail level of the image. Learn more in the Vision guide. | auto |
chatCompletionRequestMessageContentPartRefusal
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of the content part. Possible values: refusal | Yes | |
| refusal | string | The refusal message generated by the model. | Yes |
azureChatExtensionConfiguration
A representation of configuration data for a single Azure OpenAI chat extension. This will be used by a chat completions request that should use Azure OpenAI chat extensions to augment the response behavior. The use of this configuration is compatible only with Azure OpenAI.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | azureChatExtensionType | A representation of configuration data for a single Azure OpenAI chat extension. This will be used by a chat completions request that should use Azure OpenAI chat extensions to augment the response behavior. The use of this configuration is compatible only with Azure OpenAI. | Yes |
azureChatExtensionType
A representation of configuration data for a single Azure OpenAI chat extension. This will be used by a chat completions request that should use Azure OpenAI chat extensions to augment the response behavior. The use of this configuration is compatible only with Azure OpenAI. Description: A representation of configuration data for a single Azure OpenAI chat extension. This will be used by a chat completions request that should use Azure OpenAI chat extensions to augment the response behavior. The use of this configuration is compatible only with Azure OpenAI. Type: string Default: Enum Name: AzureChatExtensionType Enum Values:| Value | Description |
|---|---|
| azure_search | Represents the use of Azure Search as an Azure OpenAI chat extension. |
| azure_cosmos_db | Represents the use of Azure Cosmos DB as an Azure OpenAI chat extension. |
azureSearchChatExtensionConfiguration
A specific representation of configurable options for Azure Search when using it as an Azure OpenAI chat extension.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | azureChatExtensionType | A representation of configuration data for a single Azure OpenAI chat extension. This will be used by a chat completions request that should use Azure OpenAI chat extensions to augment the response behavior. The use of this configuration is compatible only with Azure OpenAI. | Yes | |
| parameters | azureSearchChatExtensionParameters | Parameters for Azure Search when used as an Azure OpenAI chat extension. | No |
azureSearchChatExtensionParameters
Parameters for Azure Search when used as an Azure OpenAI chat extension.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| authentication | onYourDataApiKeyAuthenticationOptions or onYourDataSystemAssignedManagedIdentityAuthenticationOptions or onYourDataUserAssignedManagedIdentityAuthenticationOptions | Yes | ||
| top_n_documents | integer | The configured top number of documents to feature for the configured query. | No | |
| in_scope | boolean | Whether queries should be restricted to use of indexed data. | No | |
| strictness | integer | The configured strictness of the search relevance filtering. The higher of strictness, the higher of the precision but lower recall of the answer. | No | |
| role_information | string | Give the model instructions about how it should behave and any context it should reference when generating a response. You can describe the assistant’s personality and tell it how to format responses. There’s a 100 token limit for it, and it counts against the overall token limit. | No | |
| endpoint | string | The absolute endpoint path for the Azure Search resource to use. | Yes | |
| index_name | string | The name of the index to use as available in the referenced Azure Search resource. | Yes | |
| fields_mapping | azureSearchIndexFieldMappingOptions | Optional settings to control how fields are processed when using a configured Azure Search resource. | No | |
| query_type | azureSearchQueryType | The type of Azure Search retrieval query that should be executed when using it as an Azure OpenAI chat extension. | No | |
| semantic_configuration | string | The additional semantic configuration for the query. | No | |
| filter | string | Search filter. | No | |
| embedding_dependency | onYourDataEndpointVectorizationSource or onYourDataDeploymentNameVectorizationSource | No |
azureSearchIndexFieldMappingOptions
Optional settings to control how fields are processed when using a configured Azure Search resource.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| title_field | string | The name of the index field to use as a title. | No | |
| url_field | string | The name of the index field to use as a URL. | No | |
| filepath_field | string | The name of the index field to use as a filepath. | No | |
| content_fields | array | The names of index fields that should be treated as content. | No | |
| content_fields_separator | string | The separator pattern that content fields should use. | No | |
| vector_fields | array | The names of fields that represent vector data. | No |
azureSearchQueryType
The type of Azure Search retrieval query that should be executed when using it as an Azure OpenAI chat extension. Description: The type of Azure Search retrieval query that should be executed when using it as an Azure OpenAI chat extension. Type: string Default: Enum Name: AzureSearchQueryType Enum Values:| Value | Description |
|---|---|
| simple | Represents the default, simple query parser. |
| semantic | Represents the semantic query parser for advanced semantic modeling. |
| vector | Represents vector search over computed data. |
| vector_simple_hybrid | Represents a combination of the simple query strategy with vector data. |
| vector_semantic_hybrid | Represents a combination of semantic search and vector data querying. |
azureCosmosDBChatExtensionConfiguration
A specific representation of configurable options for Azure Cosmos DB when using it as an Azure OpenAI chat extension.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | azureChatExtensionType | A representation of configuration data for a single Azure OpenAI chat extension. This will be used by a chat completions request that should use Azure OpenAI chat extensions to augment the response behavior. The use of this configuration is compatible only with Azure OpenAI. | Yes | |
| parameters | azureCosmosDBChatExtensionParameters | Parameters to use when configuring Azure OpenAI On Your Data chat extensions when using Azure Cosmos DB for MongoDB vCore. | No |
azureCosmosDBChatExtensionParameters
Parameters to use when configuring Azure OpenAI On Your Data chat extensions when using Azure Cosmos DB for MongoDB vCore.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| authentication | onYourDataConnectionStringAuthenticationOptions | The authentication options for Azure OpenAI On Your Data when using a connection string. | Yes | |
| top_n_documents | integer | The configured top number of documents to feature for the configured query. | No | |
| in_scope | boolean | Whether queries should be restricted to use of indexed data. | No | |
| strictness | integer | The configured strictness of the search relevance filtering. The higher of strictness, the higher of the precision but lower recall of the answer. | No | |
| role_information | string | Give the model instructions about how it should behave and any context it should reference when generating a response. You can describe the assistant’s personality and tell it how to format responses. There’s a 100 token limit for it, and it counts against the overall token limit. | No | |
| database_name | string | The MongoDB vCore database name to use with Azure Cosmos DB. | Yes | |
| container_name | string | The name of the Azure Cosmos DB resource container. | Yes | |
| index_name | string | The MongoDB vCore index name to use with Azure Cosmos DB. | Yes | |
| fields_mapping | azureCosmosDBFieldMappingOptions | Optional settings to control how fields are processed when using a configured Azure Cosmos DB resource. | Yes | |
| embedding_dependency | onYourDataEndpointVectorizationSource or onYourDataDeploymentNameVectorizationSource | Yes |
azureCosmosDBFieldMappingOptions
Optional settings to control how fields are processed when using a configured Azure Cosmos DB resource.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| title_field | string | The name of the index field to use as a title. | No | |
| url_field | string | The name of the index field to use as a URL. | No | |
| filepath_field | string | The name of the index field to use as a filepath. | No | |
| content_fields | array | The names of index fields that should be treated as content. | Yes | |
| content_fields_separator | string | The separator pattern that content fields should use. | No | |
| vector_fields | array | The names of fields that represent vector data. | Yes |
onYourDataAuthenticationOptions
The authentication options for Azure OpenAI On Your Data.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | onYourDataAuthenticationType | The authentication types supported with Azure OpenAI On Your Data. | Yes |
onYourDataAuthenticationType
The authentication types supported with Azure OpenAI On Your Data. Description: The authentication types supported with Azure OpenAI On Your Data. Type: string Default: Enum Name: OnYourDataAuthenticationType Enum Values:| Value | Description |
|---|---|
| api_key | Authentication via API key. |
| connection_string | Authentication via connection string. |
| system_assigned_managed_identity | Authentication via system-assigned managed identity. |
| user_assigned_managed_identity | Authentication via user-assigned managed identity. |
onYourDataApiKeyAuthenticationOptions
The authentication options for Azure OpenAI On Your Data when using an API key.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | onYourDataAuthenticationType | The authentication types supported with Azure OpenAI On Your Data. | Yes | |
| key | string | The API key to use for authentication. | No |
onYourDataConnectionStringAuthenticationOptions
The authentication options for Azure OpenAI On Your Data when using a connection string.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | onYourDataAuthenticationType | The authentication types supported with Azure OpenAI On Your Data. | Yes | |
| connection_string | string | The connection string to use for authentication. | No |
onYourDataSystemAssignedManagedIdentityAuthenticationOptions
The authentication options for Azure OpenAI On Your Data when using a system-assigned managed identity.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | onYourDataAuthenticationType | The authentication types supported with Azure OpenAI On Your Data. | Yes |
onYourDataUserAssignedManagedIdentityAuthenticationOptions
The authentication options for Azure OpenAI On Your Data when using a user-assigned managed identity.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | onYourDataAuthenticationType | The authentication types supported with Azure OpenAI On Your Data. | Yes | |
| managed_identity_resource_id | string | The resource ID of the user-assigned managed identity to use for authentication. | No |
onYourDataVectorizationSource
An abstract representation of a vectorization source for Azure OpenAI On Your Data with vector search.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | onYourDataVectorizationSourceType | Represents the available sources Azure OpenAI On Your Data can use to configure vectorization of data for use with vector search. | Yes |
onYourDataVectorizationSourceType
Represents the available sources Azure OpenAI On Your Data can use to configure vectorization of data for use with vector search. Description: Represents the available sources Azure OpenAI On Your Data can use to configure vectorization of data for use withvector search. Type: string Default: Enum Name: OnYourDataVectorizationSourceType Enum Values:
| Value | Description |
|---|---|
| endpoint | Represents vectorization performed by public service calls to an Azure OpenAI embedding model. |
| deployment_name | Represents an Ada model deployment name to use. This model deployment must be in the same Azure OpenAI resource, but On Your Data will use this model deployment via an internal call rather than a public one, which enables vector search even in private networks. |
onYourDataDeploymentNameVectorizationSource
The details of a vectorization source, used by Azure OpenAI On Your Data when applying vector search, that is based on an internal embeddings model deployment name in the same Azure OpenAI resource.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | onYourDataVectorizationSourceType | Represents the available sources Azure OpenAI On Your Data can use to configure vectorization of data for use with vector search. | Yes | |
| deployment_name | string | Specifies the name of the model deployment to use for vectorization. This model deployment must be in the same Azure OpenAI resource, but On Your Data will use this model deployment via an internal call rather than a public one, which enables vector search even in private networks. | No |
onYourDataEndpointVectorizationSource
The details of a vectorization source, used by Azure OpenAI On Your Data when applying vector search, that is based on a public Azure OpenAI endpoint call for embeddings.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | onYourDataVectorizationSourceType | Represents the available sources Azure OpenAI On Your Data can use to configure vectorization of data for use with vector search. | Yes | |
| authentication | onYourDataApiKeyAuthenticationOptions | The authentication options for Azure OpenAI On Your Data when using an API key. | No | |
| endpoint | string | Specifies the endpoint to use for vectorization. This endpoint must be in the same Azure OpenAI resource, but On Your Data will use this endpoint via an internal call rather than a public one, which enables vector search even in private networks. | No |
azureChatExtensionsMessageContext
A representation of the additional context information available when Azure OpenAI chat extensions are involved in the generation of a corresponding chat completions response. This context information is only populated when using an Azure OpenAI request configured to use a matching extension.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| citations | array | The data source retrieval result, used to generate the assistant message in the response. | No | |
| intent | string | The detected intent from the chat history, used to pass to the next turn to carry over the context. | No |
citation
citation information for a chat completions response message.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | string | The content of the citation. | Yes | |
| title | string | The title of the citation. | No | |
| url | string | The URL of the citation. | No | |
| filepath | string | The file path of the citation. | No | |
| chunk_id | string | The chunk ID of the citation. | No |
chatCompletionMessageToolCall
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| id | string | The ID of the tool call. | Yes | |
| type | toolCallType | The type of the tool call, in this case function. | Yes | |
| function | object | The function that the model called. | Yes |
Properties for function
name
| Name | Type | Description | Default |
|---|---|---|---|
| name | string | The name of the function to call. |
arguments
| Name | Type | Description | Default |
|---|---|---|---|
| arguments | string | The arguments to call the function with, as generated by the model in JSON format. Note that the model doesn’t always generate valid JSON, and may generate parameters not defined by your function schema. Validate the arguments in your code before calling your function. |
toolCallType
The type of the tool call, in this casefunction.
Description: The type of the tool call, in this case function.
Type: string
Default:
Enum Name: ToolCallType
Enum Values:
| Value | Description |
|---|---|
| function | The tool call type is function. |
chatCompletionRequestMessageTool
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| tool_call_id | string | Tool call that this message is responding to. | No | |
| content | string | The contents of the message. | No |
chatCompletionRequestMessageFunction
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| role | enum | The role of the messages author, in this case function.Possible values: function | No | |
| name | string | The contents of the message. | No | |
| content | string | The contents of the message. | No |
createChatCompletionResponse
Represents a chat completion response returned by model, based on the provided input.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| id | string | A unique identifier for the chat completion. | Yes | |
| prompt_filter_results | promptFilterResults | Content filtering results for zero or more prompts in the request. In a streaming request, results for different prompts may arrive at different times or in different orders. | No | |
| choices | array | A list of chat completion choices. Can be more than one if n is greater than 1. | Yes | |
| created | integer | The Unix timestamp (in seconds) of when the chat completion was created. | Yes | |
| model | string | The model used for the chat completion. | Yes | |
| system_fingerprint | string | This fingerprint represents the backend configuration that the model runs with. Can be used in conjunction with the seed request parameter to understand when backend changes have been made that might impact determinism. | No | |
| object | enum | The object type, which is always chat.completion.Possible values: chat.completion | Yes | |
| usage | completionUsage | Usage statistics for the completion request. | No |
createChatCompletionStreamResponse
Represents a streamed chunk of a chat completion response returned by model, based on the provided input.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| id | string | A unique identifier for the chat completion. Each chunk has the same ID. | Yes | |
| choices | array | A list of chat completion choices. Can contain more than one elements if n is greater than 1. | Yes | |
| created | integer | The Unix timestamp (in seconds) of when the chat completion was created. Each chunk has the same timestamp. | Yes | |
| model | string | The model to generate the completion. | Yes | |
| system_fingerprint | string | This fingerprint represents the backend configuration that the model runs with. Can be used in conjunction with the seed request parameter to understand when backend changes have been made that might impact determinism. | No | |
| object | enum | The object type, which is always chat.completion.chunk.Possible values: chat.completion.chunk | Yes |
chatCompletionStreamResponseDelta
A chat completion delta generated by streamed model responses.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | string | The contents of the chunk message. | No | |
| function_call | object | Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model. | No | |
| tool_calls | array | No | ||
| role | enum | The role of the author of this message. Possible values: system, user, assistant, tool | No | |
| refusal | string | The refusal message generated by the model. | No |
Properties for function_call
arguments
| Name | Type | Description | Default |
|---|---|---|---|
| arguments | string | The arguments to call the function with, as generated by the model in JSON format. Note that the model doesn’t always generate valid JSON, and may generate parameters not defined by your function schema. Validate the arguments in your code before calling your function. |
name
| Name | Type | Description | Default |
|---|---|---|---|
| name | string | The name of the function to call. |
chatCompletionMessageToolCallChunk
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| index | integer | Yes | ||
| id | string | The ID of the tool call. | No | |
| type | enum | The type of the tool. Currently, only function is supported.Possible values: function | No | |
| function | object | No |
Properties for function
name
| Name | Type | Description | Default |
|---|---|---|---|
| name | string | The name of the function to call. |
arguments
| Name | Type | Description | Default |
|---|---|---|---|
| arguments | string | The arguments to call the function with, as generated by the model in JSON format. Note that the model doesn’t always generate valid JSON, and may generate parameters not defined by your function schema. Validate the arguments in your code before calling your function. |
chatCompletionStreamOptions
Options for streaming response. Only set this when you setstream: true.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| include_usage | boolean | If set, an additional chunk will be streamed before the data: [DONE] message. The usage field on this chunk shows the token usage statistics for the entire request, and the choices field will always be an empty array. All other chunks will also include a usage field, but with a null value. | No |
chatCompletionChoiceLogProbs
Log probability information for the choice.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | array | A list of message content tokens with log probability information. | Yes | |
| refusal | array | A list of message refusal tokens with log probability information. | No |
chatCompletionTokenLogprob
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| token | string | The token. | Yes | |
| logprob | number | The log probability of this token. | Yes | |
| bytes | array | A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there’s no bytes representation for the token. | Yes | |
| top_logprobs | array | List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned. | Yes |
chatCompletionResponseMessage
A chat completion message generated by the model.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| role | chatCompletionResponseMessageRole | The role of the author of the response message. | Yes | |
| refusal | string | The refusal message generated by the model. | Yes | |
| content | string | The contents of the message. | Yes | |
| tool_calls | array | The tool calls generated by the model, such as function calls. | No | |
| function_call | chatCompletionFunctionCall | Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model. | No | |
| context | azureChatExtensionsMessageContext | A representation of the additional context information available when Azure OpenAI chat extensions are involved in the generation of a corresponding chat completions response. This context information is only populated when using an Azure OpenAI request configured to use a matching extension. | No |
chatCompletionResponseMessageRole
The role of the author of the response message. Description: The role of the author of the response message. Type: string Default: Enum Values:- assistant
chatCompletionToolChoiceOption
Controls which (if any) tool is called by the model.none means the model won’t call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools. Specifying a particular tool via {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool. none is the default when no tools are present. auto is the default if tools are present.
This component can be one of the following:
chatCompletionNamedToolChoice
Specifies a tool the model should use. Use to force the model to call a specific function.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of the tool. Currently, only function is supported.Possible values: function | Yes | |
| function | object | Yes |
Properties for function
name
| Name | Type | Description | Default |
|---|---|---|---|
| name | string | The name of the function to call. |
ParallelToolCalls
Whether to enable parallel function calling during tool use. No properties defined for this component.chatCompletionMessageToolCalls
The tool calls generated by the model, such as function calls. No properties defined for this component.chatCompletionFunctionCall
Deprecated and replaced bytool_calls. The name and arguments of a function that should be called, as generated by the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| name | string | The name of the function to call. | Yes | |
| arguments | string | The arguments to call the function with, as generated by the model in JSON format. Note that the model doesn’t always generate valid JSON, and may generate parameters not defined by your function schema. Validate the arguments in your code before calling your function. | Yes |
completionUsage
Usage statistics for the completion request.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| prompt_tokens | integer | Number of tokens in the prompt. | Yes | |
| completion_tokens | integer | Number of tokens in the generated completion. | Yes | |
| total_tokens | integer | Total number of tokens used in the request (prompt + completion). | Yes | |
| completion_tokens_details | object | Breakdown of tokens used in a completion. | No |
Properties for completion_tokens_details
reasoning_tokens
| Name | Type | Description | Default |
|---|---|---|---|
| reasoning_tokens | integer | Tokens generated by the model for reasoning. |
chatCompletionTool
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of the tool. Currently, only function is supported.Possible values: function | Yes | |
| function | FunctionObject | Yes |
FunctionParameters
The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format. Omittingparameters defines a function with an empty parameter list.
No properties defined for this component.
FunctionObject
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A description of what the function does, used by the model to choose when and how to call the function. | No | |
| name | string | The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64. | Yes | |
| parameters | FunctionParameters | The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format. Omitting parameters defines a function with an empty parameter list. | No | |
| strict | boolean | Whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. | No | False |
ResponseFormatText
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of response format being defined: textPossible values: text | Yes |
ResponseFormatJsonObject
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of response format being defined: json_objectPossible values: json_object | Yes |
ResponseFormatJsonSchemaSchema
The schema for the response format, described as a JSON Schema object. No properties defined for this component.ResponseFormatJsonSchema
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of response format being defined: json_schemaPossible values: json_schema | Yes | |
| json_schema | object | Yes |
Properties for json_schema
description
| Name | Type | Description | Default |
|---|---|---|---|
| description | string | A description of what the response format is for, used by the model to determine how to respond in the format. |
name
| Name | Type | Description | Default |
|---|---|---|---|
| name | string | The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64. |
schema
| Name | Type | Description | Default |
|---|---|---|---|
| schema | ResponseFormatJsonSchemaSchema | The schema for the response format, described as a JSON Schema object. |
strict
| Name | Type | Description | Default |
|---|---|---|---|
| strict | boolean | Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. | False |
chatCompletionChoiceCommon
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| index | integer | No | ||
| finish_reason | string | No |
createTranslationRequest
Translation request.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file | string | The audio file to translate. | Yes | |
| prompt | string | An optional text to guide the model’s style or continue a previous audio segment. The prompt should be in English. | No | |
| response_format | audioResponseFormat | Defines the format of the output. | No | |
| temperature | number | The sampling temperature, between 0 and 1. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. If set to 0, the model will use log probability to automatically increase the temperature until certain thresholds are hit. | No | 0 |
audioResponse
Translation or transcription response when response_format was json| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| text | string | Translated or transcribed text. | Yes |
audioVerboseResponse
Translation or transcription response when response_format was verbose_json| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| text | string | Translated or transcribed text. | Yes | |
| task | string | Type of audio task. | No | |
| language | string | Language. | No | |
| duration | number | Duration. | No | |
| segments | array | No |
audioResponseFormat
Defines the format of the output. Description: Defines the format of the output. Type: string Default: Enum Values:- json
- text
- srt
- verbose_json
- vtt
createTranscriptionRequest
Transcription request.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file | string | The audio file object to transcribe. | Yes | |
| prompt | string | An optional text to guide the model’s style or continue a previous audio segment. The prompt should match the audio language. | No | |
| response_format | audioResponseFormat | Defines the format of the output. | No | |
| temperature | number | The sampling temperature, between 0 and 1. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. If set to 0, the model will use log probability to automatically increase the temperature until certain thresholds are hit. | No | 0 |
| language | string | The language of the input audio. Supplying the input language in ISO-639-1 format will improve accuracy and latency. | No |
audioSegment
Transcription or translation segment.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| id | integer | Segment identifier. | No | |
| seek | number | Offset of the segment. | No | |
| start | number | Segment start offset. | No | |
| end | number | Segment end offset. | No | |
| text | string | Segment text. | No | |
| tokens | array | Tokens of the text. | No | |
| temperature | number | Temperature. | No | |
| avg_logprob | number | Average log probability. | No | |
| compression_ratio | number | Compression ratio. | No | |
| no_speech_prob | number | Probability of no speech. | No |
imageQuality
The quality of the image that will be generated. Description: The quality of the image that will be generated. Type: string Default: standard Enum Name: Quality Enum Values:| Value | Description |
|---|---|
| standard | Standard quality creates images with standard quality. |
| hd | HD quality creates images with finer details and greater consistency across the image. |
imagesResponseFormat
The format in which the generated images are returned. Description: The format in which the generated images are returned. Type: string Default: url Enum Name: ImagesResponseFormat Enum Values:| Value | Description |
|---|---|
| url | The URL that provides temporary access to download the generated images. |
| b64_json | The generated images are returned as base64 encoded string. |
imageSize
The size of the generated images. Description: The size of the generated images. Type: string Default: 1024x1024 Enum Name: Size Enum Values:| Value | Description |
|---|---|
| 1792x1024 | The desired size of the generated image is 1792x1024 pixels. |
| 1024x1792 | The desired size of the generated image is 1024x1792 pixels. |
| 1024x1024 | The desired size of the generated image is 1024x1024 pixels. |
imageStyle
The style of the generated images. Description: The style of the generated images. Type: string Default: vivid Enum Name: Style Enum Values:| Value | Description |
|---|---|
| vivid | Vivid creates images that are hyper-realistic and dramatic. |
| natural | Natural creates images that are more natural and less hyper-realistic. |
imageGenerationsRequest
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| prompt | string | A text description of the desired image(s). The maximum length is 4,000 characters. | Yes | |
| n | integer | The number of images to generate. | No | 1 |
| size | imageSize | The size of the generated images. | No | 1024x1024 |
| response_format | imagesResponseFormat | The format in which the generated images are returned. | No | url |
| user | string | A unique identifier representing your end-user, which can help to monitor and detect abuse. | No | |
| quality | imageQuality | The quality of the image that will be generated. | No | standard |
| style | imageStyle | The style of the generated images. | No | vivid |
generateImagesResponse
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| created | integer | The unix timestamp when the operation was created. | Yes | |
| data | array | The result data of the operation, if successful | Yes |
imageResult
The image url or encoded image if successful, and an error otherwise.| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| url | string | The image url. | No | |
| b64_json | string | The base64 encoded image | No | |
| content_filter_results | dalleContentFilterResults | Information about the content filtering results. | No | |
| revised_prompt | string | The prompt that was used to generate the image, if there was any revision to the prompt. | No | |
| prompt_filter_results | dalleFilterResults | Information about the content filtering category (hate, sexual, violence, self_harm), if it has been detected, as well as the severity level (very_low, low, medium, high-scale that determines the intensity and risk level of harmful content) and if it has been filtered or not. Information about jailbreak content and profanity, if it has been detected, and if it has been filtered or not. And information about customer blocklist, if it has been filtered and its id. | No |